package com.sun.org.apache.bcel.internal.classfile;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.DataInput;

public final class ConstantString extends Constant implements ConstantObject
{
    private int string_index;
    
    public ConstantString(ConstantString c) {
        this(c.getStringIndex());
    }
    
    ConstantString(DataInput file) throws IOException {
        this(file.readUnsignedShort());
    }
    
    public ConstantString(int string_index) {
        super((byte)8);
        this.string_index = string_index;
    }
    
    @Override
    public void accept(Visitor v) {
        v.visitConstantString(this);
    }
    
    @Override
    public final void dump(DataOutputStream file) throws IOException {
        file.writeByte((int)super.getTag());
        file.writeShort(this.string_index);
    }
    
    public final int getStringIndex() {
        return this.string_index;
    }
    
    public final void setStringIndex(int string_index) {
        this.string_index = string_index;
    }
    
    @Override
    public final String toString() {
        return super.toString() + "(string_index = " + this.string_index + ")";
    }
    
    @Override
    public Object getConstantValue(ConstantPool cp) {
        Constant c = cp.getConstant(this.string_index, (byte)1);
        return ((ConstantUtf8)c).getBytes();
    }
    
    public String getBytes(ConstantPool cp) {
        return (String)this.getConstantValue(cp);
    }
}
